use utf8;

'' => {
	desc => "normal mode",

	'~' => ["toggle case", "co undo"],
	'!' => ["external filter", "co argm undo"],
	'@' => ["play macro", "co arg undo"],
	'#' => ["rev. find word", "pm vim"],
	'$' => ["eol", "pm"],
	'%' => ["goto match", "pm"],
	'^' => ['"soft" bol', "pm"],
	'&' => ["repeat :s", "co undo"],
	'*' => ["find word", "pm vim"],
	'(' => ["begin sentence", "pm"],
	')' => ["end sentence", "pm"],
	'_' => ['"soft" bol down', "pm"],
	'+' => ["next line", "pm"],
	'`' => ["goto mark", "pm arg"],
	'0' => ['"hard" bol', "pm"],
	'-' => ["prev line", "pm"],
	'=' => ["auto form$sign{_}at", "co argm undo"],
	'?' => ["find rev.", "pm arg"],
	';' => ["repeat t/T/f/F", "pm"],
	':' => ["ex cmd line", "co"],
	"'" => ["goto mark bol", "pm arg"],
	'"' => ["use register", "co arg"],
	'\\' => ["not used", "me arg"],
	'^\\' => ["to mode/$sign{_}ext$sign{_}ens$sign{_}ion$sign{_}s", "mo arg"],
	',' => ["reverse t/T/f/F", "pm"],
	'<' => ["un­$sign{_}indent", "co argm undo"],
	'.' => ["repeat cmd", "co undo"],
	'>' => ["ident", "co argm undo"],
	'/' => ["find", "pm arg"],
	'[' => ["move back$sign{_}ward$sign{_}s", "me arg mode["],
	'{' => ["begin parag.", "pm"],
	']' => ["move forw$sign{_}ard", "me arg mode]"],
	'}' => ["end parag.", "pm"],
	'^]'=> ["go to tag", "po"],
	'|' => ["bol/$sign{_}goto col", "pm"],

	'a' => ["append", "mi undo modei"],
	'A' => ["append to eol", "mi undo modei"],
	'^a'=> ["incr$sign{_}ement", "co undo", "Add one"],
	'b' => ["prev word", "pm"],
	'B' => ['prev <span style="font-variant:small-caps">word</span>', "pm"],
	'^b'=> ["page up", "pm"],
	'c' => ["change", "mi argm undo modei"],
	'C' => ["change to eol", "mi undo modei"],
	'^c'=> ["abort", "co"],
	'd' => ["delete", "co argm undo"],
	'D' => ["delete to eol", "co undo"],
	'^d'=> ["scroll down", "po"],
	'e' => ["end word", "pm"],
	'E' => ['end <span style="font-variant:small-caps">word</span>', "pm"],
	'^e'=> ["window down", "po", "Extra line"],
	'f' => ["fwd to char", "pm arg"],
	'F' => ['backwd to char', "pm arg"],
	'^f'=> ["page down", "pm"],
	'g' => ["extra cmds", "me arg modeg"],
	'G' => ["eof/$sign{_}goto ln", "pm"],
	'^g'=> [":file (info)", "ci"],
	'h' => [$sign{left}, "pm"],
	'H' => ["screen top", "pm"],
	'^h'=> "h",
	'i' => ["insert mode", "mi undo modei"],
	'I' => ["insert at bol", "mi undo modei"],
	'^i'=> ["jump to newer", "pm"],
	'j' => [$sign{down}, "pm"],
	'J' => ["join lines", "co undo"],
	'^j'=> "j",
	'k' => [$sign{up}, "pm"],
	'K' => ["help", "co"],
	'l' => [$sign{right}, "pm"],
	'L' => ["screen bottom", "pm"],
	'^l'=> ["redraw", "ci"],
	'm' => ["set mark", "co arg"],
	'M' => ["screen mid'l", "pm"],
	'^m'=> "+",
	'n' => ["next find", "pm"],
	'N' => ["prev find", "pm"],
	'^n'=> "j",
	'o' => ["open below", "mi undo modei"],
	'O' => ["open above", "mi undo modei"],
	'^o'=> ["jump to older", "pm"],
	'p' => ["paste after", "co undo"],
	'P' => ["paste before", "co undo"],
	'^p'=> "k",
	'q' => ["record macro", "mo arg"],
	'Q' => ["ex mode", "mo"],
	'^q'=> ["(xon) or ^v", "mv modev"],
	'r' => ["replace char", "co arg undo"],
	'R' => ["replace mode", "mi undo modei"],
	'^r'=> ["redo", "co undo"],
	's' => ["subst char", "mi undo modei"],
	'S' => ["subst line", "mi undo modei"],
	'^s'=> ["(xoff)", "co"],
	't' => ["till char", "pm arg"],
	'T' => ["back till char", "pm"],
	'^t'=> ["previous tag", "po"],
	'u' => ["undo", "co undo"],
	'U' => ["undo line", "co undo"],
	'^u'=> ["scroll up", "po"],
	'v' => ["visual mode", "mv modev"],
	'V' => ["visual lines", "mv modev"],
	'^v'=> ["visual block", "mv modev"],
	'w' => ["next word", "pm"],
	'W' => ['next <span style="font-variant:small-caps">word</span>', "pm"],
	'^w'=> ["window cmds", "me arg mode^w"],
	'x' => ["delete char", "co undo"],
	'X' => ["back­$sign{_}space", "co undo"],
	'^x'=> ["subs$sign{_}tract", "co undo"],
	'y' => ["yank", "co argm"],
	'Y' => ["yank line", "co"],
	'^y'=> ["window up", "po"],
	'z' => ["extra cmds", "me arg modez"],
	'Z' => ["quit", "me arg modeZ"],
	'^z'=> [":sus$sign{_}pend", "co"],
}, # normal mode

v => {
	desc => "visual mode",

	'!' => ["external filter", "co"],
	':' => ["cmd with range", "mo"],
	'<' => ["un$sign{_}indent", "co"],
	'=' => ["equalprg filter", "co"],
	'>' => ["indent", "co"],
	'~' => ["toggle case", "co"],
	'^]'=> ["jump to tag", "po"],

	'a' => ["extend area", "me arg"], # XXX mode
	'A' => ["append to block", "mi modei"], # block
	'c' => ["replace area", "mi modei"],
	'C' => ["change", "mi modei"],
	'^c'=> ["abort", "mo mode"],
	'd' => ["delete area", "co"],
	'D' => ["delete lines", "co"],
	'g' => ["extra cmds", "me arg modevg"],
	'^g'=> ["select mode", "mv"],
	'^h'=> ["delete area", "co"], # select
	'i' => ["extend area", "me arg"],
	'I' => ["insert to block", "mi modei"], # block
	'J' => ["join lines", "co"],
	'K' => ["keyword$sign{_}prg", "co"],
	'o' => ["to other corner", "pm"],
	'O' => ["to other side", "pm"],
	'^o'=> ["visual once", "mv"], # select
	'p' => ["replace w/ paste", "co"],
	'P' => ["replace w/ paste", "co"],
	'^q'=> ["(xon)", "co"],
	'r' => ["replace chars", "co arg"],
	'R' => ["replace lines", "mi modei"],
	's' => ["replace area", "mi modei"],
	'S' => ["replace lines", "mi modei"],
	'u' => ["lower$sign{_}case", "co"],
	'U' => ["upper$sign{_}case", "co"],
	'v' => ["char$sign{_}wise", "mv"],
	'V' => ["line$sign{_}wise", "mv"],
	'^v'=> ["block$sign{_}wise", "mv"],
	'x' => ["delete area", "co"],
	'X' => ["delete lines", "co"],
	'y' => ["yank area", "co"],
	'Y' => ["yank lines", "co"],

	map {$_ => $_} qw(
		b B ^b ^d e E ^e f F ^f G h H ^i j ^j k l L m M ^m
		n N ^n ^p q ^s t T ^u w W ^w ^y z ^z
		` # $ % ^ * ( 0 ) [ { ] } ; / ? + - _ |
	) # a lot like normal mode
}, # mode v

vg => {
	desc => "extended visual commands (v g)",
	lead => "g",

	'J' => ["join leave spacing", "co vim"],
	'q' => ["format", "co"],
	'v' => ["previous highl$sign{_}ight", "co"],
	'^['=> ["esc", "mv modev"],
}, # mode v g

i => {
	desc => "insert mode",

	'^2' => ["last insert", "co"],
	'^6' => ["toggle :lmap usag$sign{_}e", "co vim"],
	'^[' => ["esc", "mo mode"],
	'^]' => ["abbrev$sign{_}iate", "co vim"],
	'^-' => ["change lang$sign{_}uage", "co vim"],
	'^\\'=> ["switch mode", "mo arg"],

	'^a' => ["insert prev$sign{_}ious", "co vim"],
	'^b' => ["former i^-", "co"],
	'^c' => ["abort, no abbr", "mo mode"],
	'^d' => ["un$sign{_}indent", "co"],
	'^e' => ["ins char below", "co vim"],
	'^f' => ["cinkeys: re-indent", "co"],
	'^g' => ["start column", "pm arg"], #todo
	'^h' => ["back$sign{_}space", "co"],
	'^i' => ["tab", "co"],
	'^j' => ["enter", "co"],
	'^k' => ["di$sign{_}graph", "co arg arg vim"],
	'^l' => ["leave ins mode", "mo mode"],
	'^m' => ["enter", "co"],
	'^n' => ["find next keyword", "pm vim"],
	'^o' => ["execute cmd", "co"],
	'^p' => ["find prev keyword", "pm vim"],
	'^q' => ["(xon) or i^v", "co"],
	'^r' => ["insert register", "co vim"],
	'^s' => ["(xoff)", "co"],
	'^t' => ["indent", "co"],
	'^u' => ["delete line", "co"],
	'^v' => ["literal or char$sign{_}cod$sign{_}e", "co"],
	'^w' => ["delete word back", "co"],
	'^x' => ["expand mode", "me arg modei^x vim"],
	'^y' => ["ins char above", "co vim"],
	'^z' => [":suspend", "co"],
}, # modei

'i^x' => {
	desc => "insert completion commands (i ctrl-x)",
	lead => $ascii ? "'x"  : "x̂",

	'^d' => ["complete defines", "co"],
	'^e' => ["window up", "po"],
	'^f' => ["complete file$sign{_}name$sign{_}s", "co"],
	'^i' => ["complete idents", "co"],
	'^k' => ["complete dict", "co"],
	'^l' => ["complete lines", "co"],
	'^n' => ["next complete", "co"],
	'^o' => ["omni complete", "co"],
	'^p' => ["previous complete", "co"],
	'^s' => ["spell suggest", "co"],
	'^t' => ["complete thesaur$sign{_}us", "co"],
	'^u' => ["complete$sign{_}func", "co"],
	'^v' => ["complete ex cmd", "co"],
	'^y' => ["window down", "po"],
	'^[' => ["esc", "mo mode"],
	'^]' => ["complete tags", "co"],
}, # mode i ^x

g => {
	desc => "extended commands (g)",
	lead => "g",

	'~' => ["toggle case", "co argm"],
	'@' => ["operat$sign{_}or$sign{_}func", "co vim7"],
	'#' => ["rev. find string", "pm vim"],
	'$' => ["virt$sign{_}ual eol", "pm"],
	'^' => ['"soft" bol v$sign{_}irt$sign{_}ual', "pm vim"],
	'&' => ["repeat :s global$sign{_}ly", "co", "Global substitute"],
	'*' => ["find string", "pm vim"],
	'_' => ['"soft" eol', "pm vim"],
	'+' => ["later undo", "co vim7"],
	'`' => ["to mark keepj$sign{_}umps", "pm vim arg"],
	'8' => ["char hex val$sign{_}ue$sign{_}s", "ci"],
	'0' => ["virtual bol", "pm vim"],
	'-' => ["earlier undo", "co vim7"],
	'^['=> ["esc", "mo mode"],
	']' => ["go to tselect", "po"],
	'^]'=> ["go to tjump", "po"],
	';' => ["to prev change pos", "pm"],
	"'" => ["to mark keepj$sign{_}umps", "pm vim arg"],
	'<' => ["see prev cmd output", "co vim7"],
	'?' => ["rot13 encode", "co argm"],
	',' => ["to next change pos", "pm"],

	'a' => ["char value", "ci", "Get Ascii value"],
	'^a'=> ["mem usage stats", "ci"],
	'd' => ["local declar$sign{_}ation", "pm vim"],
	'D' => ["global declar$sign{_}ation", "pm vim"],
	'e' => ["back to word end", "pm"],
	'E' => ['back to <span style="font-variant:small-caps">word</span> end', "pm"],
	'f' => ["edit file at cur$sign{_}sor", "co vim", "Goto File"],
	'F' => ["edit file + jump", "co vim7"],
	'g' => ["first line", "pm"],
	'^g'=> ["cursor pos info", "ci"],
	'h' => ["select mode", "mv modev", "Get Highlighted"],
	'H' => ["select lines", "mv modev", "Get Highlighted"],
	'^h'=> ["select block", "mv modev", "Get Highlighted"],
	'i' => ["insert at last pos", "mi undo modei"],
	'I' => ["insert at soft bol", "mi undo modei"],
	'j' => ["display line down", "pm vim"],
	'J' => ["join leave spac$sign{_}ing", "co"],
	'k' => ["display line up", "pm vim"],
	'm' => ["g0 right half scr$sign{_}een", "pm vim"],
	'o' => [":goto (byte)", "pm"],
	'p' => ["paste no move", "co undo"],
	'P' => ["paste before no move", "co"],
	'q' => ["format", "co argm"],
	'Q' => ["ex mode manual :", "mo"],
	'r' => ["replace char vir.", "co arg"],
	'R' => ["replace mode v$sign{_}ir$sign{_}t$sign{_}ual", "mi undo modei"],
	's' => ["sleep", "ci", "Go to Sleep"],
	't' => ["next tab", "po vim7", "Goto Tab"],
	'T' => ["previous tab", "po vim7"],
	'u' => ["lower$sign{_}case", "co argm"],
	'U' => ["upper$sign{_}case", "co undo argm"],
	'v' => ["previous visual mode", "mv modev", "precedinG Visual"],
	'V' => ["avoid reselect$sign{_}ion", "co"],
	'w' => ["format remain cursor", "co argm"],
	'x' => ["Netrw$sign{_}BrowseX", "co vim7"],
}, # mode g

Z => {
	desc => "additional commands (z)",
	lead => "Z",

	'^['=> ["esc", "mo mode"],

	'Q' => [" :q!", "co"],
	'Z' => [" :wq", "co"],
}, # mode Z

z => {
	desc => "quit commands",
	lead => "z",

	'^' => ["page above", "po"],
	'+' => ["page below", "po"],
	'-' => ["line at bottom bol", "po", "don't (-) see any further"],
	'=' => ["spelling suggest$sign{_}ions", "co vim7"],
	'.' => ["line at center bol", "po"],
	'^['=> ["esc", "mo mode"],

	'a' => ["toggle fold", "co vim folding"],
	'A' => ["toggle fold rec$sign{_}urs$sign{_}ive$sign{_}ly", "co vim folding"],
	'b' => ["line at bot. bol", "po"],
	'c' => ["close fold", "co vim folding"],
	'C' => ["close folds rec$sign{_}curs$sign{_}ive$sign{_}ly", "co vim folding"],
	'd' => ["delete fold", "co vim folding"],
	'D' => ["delete folds rec$sign{_}urs$sign{_}ive", "co vim folding"],
	'e' => ["cursor at right side", "po"],
	'E' => ["eliminate folds", "co vim folding"],
	'f' => ["create fold", "co argm vim folding"],
	'F' => ["fold lines", "co vim folding"],
	'g' => ["correct spell$sign{_}ing", "co vim7", "Good word"],
	'G' => ["ignore spell$sign{_}ing", "co vim7"],
	'h' => ["scroll $sign{right}", "po"],
	'H' => ["scroll $sign{right} half scr$sign{_}een", "po"],
	'i' => ["toggle all folds", "co vim folding"],
	'j' => ["next fold start", "pm vim folding"],
	'k' => ["prev fold end", "pm vim folding"],
	'l' => ["scroll $sign{left}", "po"],
	'L' => ["scroll $sign{left} half scr$sign{_}een", "po"],
	'^m'=> ["line at top bol", "po"],
	'm' => ["fold more", "co vim folding"],
	'M' => ["close all folds", "co vim folding"],
	'n' => ["fold none", "co vim folding"],
	'N' => ["fold normal", "co vim folding"],
	'o' => ["open fold", "co vim folding"],
	'O' => ["open folds rec$sign{_}urs$sign{_}ive$sign{_}ly", "co vim folding"],
	'r' => ["reduce folding", "co vim folding"],
	'R' => ["open all folds", "co vim folding"],
	's' => ["cursor at left side", "po"],
	't' => ["line at top", "po"],
	'v' => ["unfold cursor line", "co vim folding"],
	'w' => ["add misspell$sign{_}ing", "co vim7", "Wrong word"],
	'W' => ["temp misspell$sign{_}ing", "co vim7"],
	'x' => ["update folds", "co vim folding"],
	'X' => ["reapply folds", "co vim folding"],
	'z' => ["line at center", "po", "Zee Zenter (with an accent)"],
}, # mode z

'[' => {
	desc => "backward search commands ([)",
	lead => "[",

	"`" => ["previous lc mark", "pm vim"],
	'#' => ["previous open #if$sign{_}/#else", "pm"],
	'(' => ["previous open (", "pm"],
	'*' => "[/",
	'/' => ["start of C comm$sign{_}ent", "pm"],
	"'" => "[` ^", # vim
	'{' => ["previous open {", "pm"],
	'[' => ["section back$sign{_}ward$sign{_}s", "pm"],
	'^['=> ["esc", "mo mode"],
	']' => ['<span style="font-variant:small-caps">section</span> back$sign{_}ward$sign{_}s', "pm"],

	'c' => ["start of change backw$sign{_}ards", "pm"],
	'd' => ["list define", "co"],
	'D' => ["list defines", "co"],
	'^d'=> ["first #define", "po"],
	'f' => "gf",
	'i' => ["list line", "co"],
	'I' => ["list lines", "co"],
	'^i'=> ["first occur$sign{_}renc$sign{_}e", "po"],
	'm' => ["start of funct$sign{_}ion", "pm"],
	'p' => ["P but reindent", "co"],
	'P' => ["[p", "co"],
	's' => ["last mis$sign{_}spell$sign{_}ing", "po vim7"],
	'S' => ["last bad word", "po vim7"],
	'z' => ["start of open fold", "pm vim folding"],
}, # mode [

']' => {
	desc => "forward search commands (])",
	lead => "]",

	"`" => ["next lc mark", "pm vim"],
	'#' => ["next open #endif$sign{_}/#else", "pm"],
	')' => ["next open )", "pm"],
	'*' => "]/",
	"'" => "]` ^", # vim
	'/' => ["end of C comm$sign{_}ent", "pm"],
	'[' => ['<span style="font-variant:small-caps">section</span> forw$sign{_}ard', "pm"],
	'^['=> ["esc", "mo mode"],
	']' => ["section forw$sign{_}ard", "pm"],
	'}' => ["next open }", "pm"],

	'c' => ["start of change forw$sign{_}ards", "pm"],
	'd' => ["list define", "co"],
	'D' => ["list defines", "co"],
	'^d'=> ["first #define", "po"],
	'f' => ["gf", "co"],
	'i' => ["list line", "co"],
	'I' => ["list lines", "co"],
	'^i'=> ["first occur$sign{_}renc$sign{_}e", "po"],
	'm' => ["end of funct$sign{_}ion", "pm"],
	'p' => ["p but reindent", "co"],
	'P' => "[p",
	's' => ["next mis$sign{_}spell$sign{_}ing", "po vim7"],
	'S' => ["next bad word", "po vim7"],
	'z' => ["end of open fold", "pm vim folding"],
}, # mode ]

'^w' => {
	desc => "window commands (ctrl-w)",
	lead => $ascii ? "'w"  : "ŵ",

	'<' => ["decrease width", "po"],
	'>' => ["increase width", "po"],
	'^' => ["split, edit alt file", "co"],
	'_' => ["set height", "po"],
	'+' => ["increase height", "po"],
	'-' => ["decrease height", "po"],
	'=' => ["same height", "po"],
	'^['=> ["esc", "mo mode"],
	']' => ["split, to tag", "po"],
	'}' => ["tag in preview", "po"],
	'|' => ["set width", "po"],

	'b' => ["go to bottom", "po"],
	'c' => [":close", "po"],
	'^c'=> ["abort", "mo mode"],
	'd' => ["split, to def$sign{_}inition", "po"],
	'f' => ["split, edit file", "co"],
	'F' => ["^wf, jump to line", "co vim7"],
	'g' => ["extra cmds", "me arg mode^wg"],
	'h' => ["go left", "po"],
	'H' => ["move far left", "po"],
	'i' => ["split, to decl of id$sign{_}ent$sign{_}ifier", "po"],
	'j' => ["go down", "po"],
	'J' => ["move to bottom", "po"],
	'k' => ["go up", "po"],
	'K' => ["move to top", "po"],
	'l' => ["go right", "po"],
	'L' => ["move far right", "po"],
	'n' => ["open new", "co"],
	'o' => [":only current", "po"],
	'p' => ["go to previous", "po"],
	'P' => ["go to preview", "po"],
	'q' => [":quit current", "co"],
	'r' => ["rotate down$sign{_}ward$sign{_}s", "po"],
	'R' => ["rotate up$sign{_}ward$sign{_}s", "po"],
	's' => ["split horiz$sign{_}ont$sign{_}al$sign{_}ly", "po"],
	'S' => "^ws",
	't' => ["go to top", "po"],
	'v' => ["split vertical$sign{_}ly", "po"],
	'w' => ["go to next", "po", "Wrap around"],
	'W' => ["go above$sign{_}/left", "po"],
	'x' => ["ex$sign{_}change", "po"],
	'z' => ["close preview", "po"],
}, # mode ^w

'^wg' => {
	desc => "extended window commands (ctrl-w g)",
	lead => $ascii ? "'wg" : "ŵg",

	'^['=> ["esc", "mo mode"],
	']' => ["split, :tselect", "po"],
	'}' => [":ptjump to tag", "po"],
	'^]'=> ["split, :tjump", "po"],
	'f' => ["edit file in tab", "co vim7"],
	'F' => ["^wgf, to line$sign{_}nr", "co vim7"],
}, # mode ^w g

